%define srcname lua
%define major 5.0
%define minor 3
%define name %{srcname}%{major}
%define libname %mklibname %{name}
%define develname %mklibname %{name} -d
%define staticname %mklibname %{name} -d -s
%define alt_priority %(echo %{major} | sed -e 's/[^0-9]//g')

Summary:	Lua is a powerful, light-weight programming language
Name:		%{name}
Version:	%{major}.%{minor}
Release:	%mkrel 5
License:	MIT
URL:		http://www.lua.org/
Group:		Development/Other
Source0:	http://www.lua.org/ftp/lua-%{version}.tar.bz2
Patch0:		lua-config.patch
Patch1:		lua-lbaselib.patch
Patch2:		lua-default.patch
Patch3:		lua-soname.patch
Provides:	lua%{major}
Provides:	lua = %{version}
BuildRequires:	%{_lib}readline-devel
BuildRequires:	ncurses-devel
BuildRoot:	%{_tmppath}/%{srcname}-%{version}-%{release}-buildroot

%description
Lua is a programming language originally designed for extending applications, 
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data 
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in 
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

#german
%description -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{libname}
Summary:	Lua is a powerful, light-weight programming language
Group:		System/Libraries

%description -n %{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package includes the libraries.

#german
%description -n %{libname} -l de
Lua ist eine mächtige leichtgewichtige Programmiersprache. Lua ist eine 
Programmiersprache die ursprünglich zum Erweitern von Anwendungen entworfen 
wurde, sie wird aber häufig als allgemeine, eigenständige Sprache verwendet. 
LUA kombiniert einfache prozedurale Syntax (vergleichbar mit der Pascal-Schreibweise) 
mit leistungsstarken Daten Beschreibungen, Konstrukte Grundlagen, assoziativen Arrays 
und erweiterbare Semantik. LUA wird dynamisch eingegeben, aus Bytecodes interpretiert 
und hat eine automatische Speicherverwaltung, wodurch sich ideal für Konfigurationen, 
Skripte und schnelle Prototypen eignet. LUA wird als eine kleine Bibliothek von 
C-Funktionen in ANSI C geschrieben sowie kompiliert und unverändert in allen bekannten 
Plattformen implementiert. Die Implementierungsziele sind Einfachheit Effizienz, 
Portabilität und niedrige Kosten mit einander zu verbinden.

%package -n %{develname}
Summary:	Headers and development files for Lua
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
# to have the same provides on all arches
Provides:	lua%{major}-devel = %{version}-%{release}
Provides:	lua-devel = %{version}-%{release}
# for backward compat
Provides:	liblua-devel = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel < %{version}
Conflicts:	lua-devel > %{version}
Conflicts:	%{libname}-devel-static < %{version}
Conflicts:	%{libname}-static-devel < %{version}

%description -n %{develname}
This package contains the headers and development files for Lua.

#german
%description -n %{develname} -l de
Dieses Paket enthält die Header und Entwicklungsdateien für LUA.

%package -n %{staticname}
Summary:	Static development files for Lua
Group:		Development/Other
Requires:	%{libname}-devel = %{version}
# to have the same provides on all arches
Provides:	lua-devel-static = %{version}-%{release}
Provides:	lua%{major}-devel-static = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel-static < %{version}
Conflicts:	lua-devel-static > %{version}
Conflicts:	%{libname}-devel-static < %{version}
Conflicts:	%{libname}-static-devel < %{version}

%description -n %{libname}-static-devel
This package contains the static development files for Lua.

%prep
%setup -q -n %{srcname}-%{version}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p0 -b .soname

%build

%ifarch x86_64
fpic="-fPIC"
%endif
%make MYCFLAGS="$RPM_OPT_FLAGS ${fpic}"
make so

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std INSTALL_LIB=%buildroot%_libdir
install -d $RPM_BUILD_ROOT%{_libdir}/lua/%{major}/
install -d $RPM_BUILD_ROOT%{_datadir}/lua/%{major}/
install -m 755 lib/*.so.* $RPM_BUILD_ROOT%{_libdir}/
cp -a lib/*.so $RPM_BUILD_ROOT%{_libdir}/
install -m 644 lib/*.lua $RPM_BUILD_ROOT%{_datadir}/lua/%{major}/

# for update-alternatives
mv $RPM_BUILD_ROOT/%{_bindir}/lua $RPM_BUILD_ROOT/%{_bindir}/lua%{major}
mv $RPM_BUILD_ROOT/%{_bindir}/luac $RPM_BUILD_ROOT/%{_bindir}/luac%{major}

# to avoid conflict with other versions
mv $RPM_BUILD_ROOT/%{_mandir}/man1/lua.1 $RPM_BUILD_ROOT/%{_mandir}/man1/lua%{major}.1
mv $RPM_BUILD_ROOT/%{_mandir}/man1/luac.1 $RPM_BUILD_ROOT/%{_mandir}/man1/luac%{major}.1

%clean
rm -rf $RPM_BUILD_ROOT


%post
/usr/sbin/update-alternatives --install %{_bindir}/lua lua %{_bindir}/lua%{major} %{alt_priority} --slave %{_bindir}/luac luac %{_bindir}/luac%{major}

%post -n %{libname}
/sbin/ldconfig

%postun
[[ -f %_bindir/lua%{major} ]] || /usr/sbin/update-alternatives --remove lua %{_bindir}/lua%{major}

%postun -n %{libname}
/sbin/ldconfig


%files
%defattr (-,root,root)
%doc COPYRIGHT HISTORY INSTALL MANIFEST README
%doc doc/*.html doc/*.gif
%{_bindir}/*
%dir %{_libdir}/lua
%{_libdir}/lua/%{major}
%{_datadir}/lua/%{major}/*.lua
%{_mandir}/man1/*

%files -n %{libname}
%defattr (-,root,root)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr (-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.a

%files -n %{libname}-static-devel
%defattr (-,root,root)
%{_libdir}/*.a

%changelog
* Tue Oct 16 2012 Neal <nealbrks0 at gmail dot com> 5.0.3-5pclos2012
- process

* Fri Oct 05 2012 gseaman <galen.seaman at comcast.net> 5.0.3-5gseaman2012
- sync spec files between 5.0, 5.1 and 5.2

* Sat Dec 30 2006 Torbjorn Turpeinen <tobbe@nyvalls.se> 5.0-4
- initial build for pclinuxos 2007
